#
# Copyright 2024 by Delphix
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# This class has been automatically generated from:
#     /delphix-repave-apply-parameters-object-store.json
#
# Do not edit this file manually!
#

from delphixpy.v1_11_40.web.objects.RepaveApplyParameters import RepaveApplyParameters
from delphixpy.v1_11_40 import factory
from delphixpy.v1_11_40 import common

class __Undef:
    def __repr__(self):
        return "undef"

    def __setattr__(self, name, value):
        raise Exception('Cannot modify attributes of __Undef.')

_UNDEFINED = __Undef()

class ObjectStoreRepaveApplyParameters(RepaveApplyParameters):
    """
    *(extends* :py:class:`v1_11_40.web.vo.RepaveApplyParameters` *)* Object
    store parameters for repave apply.
    """
    def __init__(self, undef_enabled=True):
        super().__init__()
        self._type = ("ObjectStoreRepaveApplyParameters", True)
        self._cache_devices = (self.__undef__, True)
        self._domain0_pool_guid = (self.__undef__, True)


    @classmethod
    def from_dict(cls, data, dirty=False, undef_enabled=True):
        obj = super().from_dict(data, dirty, undef_enabled)
        if "cacheDevices" in data and data["cacheDevices"] is not None:
            obj._cache_devices = (factory.create_object(data["cacheDevices"], "RepaveCacheDevices"), dirty)
            factory.validate_type(obj._cache_devices[0], "RepaveCacheDevices")
        else:
            obj._cache_devices = (obj.__undef__, dirty)
        obj._domain0_pool_guid = (data.get("domain0PoolGUID", obj.__undef__), dirty)
        if obj._domain0_pool_guid[0] is not None and obj._domain0_pool_guid[0] is not obj.__undef__:
            assert isinstance(obj._domain0_pool_guid[0], str), ("Expected one of ['string'], but got %s of type %s" % (obj._domain0_pool_guid[0], type(obj._domain0_pool_guid[0])))
            common.validate_format(obj._domain0_pool_guid[0], "None", None, None)
        return obj

    def to_dict(self, dirty=False, belongs_to_parent=False):
        dct = super().to_dict(dirty, belongs_to_parent)

        def dictify(obj, prop_is_list_or_vo=False):
            if isinstance(obj, list):
                return [dictify(o, prop_is_list_or_vo) for o in obj]
            elif hasattr(obj, "to_dict"):
                return obj.to_dict(dirty=dirty, belongs_to_parent=prop_is_list_or_vo)
            else:
                return obj
        if "cache_devices" == "type" or (self.cache_devices is not self.__undef__ and (not (dirty and not self._cache_devices[1]) or self.is_dirty_list(self.cache_devices, self._cache_devices) or belongs_to_parent)):
            dct["cacheDevices"] = dictify(self.cache_devices, prop_is_list_or_vo=True)
        if "domain0_pool_guid" == "type" or (self.domain0_pool_guid is not self.__undef__ and (not (dirty and not self._domain0_pool_guid[1]) or self.is_dirty_list(self.domain0_pool_guid, self._domain0_pool_guid) or belongs_to_parent)):
            dct["domain0PoolGUID"] = dictify(self.domain0_pool_guid)
        return dct

    def dirty(self):
        return self.from_dict(self.to_dict(dirty=False), dirty=True)

    def force_dirty(self):
        self._cache_devices = (self._cache_devices[0], True)
        self._domain0_pool_guid = (self._domain0_pool_guid[0], True)

    def is_dirty(self):
        return any([self._cache_devices[1], self._domain0_pool_guid[1]])

    def is_dirty_list(self, prop_name, private_var):
        if isinstance(prop_name, list) and prop_name and hasattr(prop_name[0], 'type'):
            for item in prop_name:
                if isinstance(item, list):
                    if self.is_dirty_list(item) or item.is_dirty():
                        return True
                elif item.is_dirty():
                    return True
        else:
            return private_var[1]
        return False

    def __eq__(self, other):
        if other is None:
            return False
        if not isinstance(other, ObjectStoreRepaveApplyParameters):
            return False
        return super().__eq__(other) and \
               self.cache_devices == other.cache_devices and \
               self.domain0_pool_guid == other.domain0_pool_guid

    def __ne__(self, other):
        return not self.__eq__(other)

    def __hash__(self):
        return id(self)

    def __repr__(self):
        return common.generate_repr_string(self)

    @property
    def cache_devices(self):
        """
        Cache devices of object store.

        :rtype: :py:class:`v1_11_40.web.vo.RepaveCacheDevices`
        """
        return self._cache_devices[0]

    @cache_devices.setter
    def cache_devices(self, value):
        self._cache_devices = (value, True)

    @property
    def domain0_pool_guid(self):
        """
        GUID of DOMAIN0 Pool.

        :rtype: ``str``
        """
        return self._domain0_pool_guid[0]

    @domain0_pool_guid.setter
    def domain0_pool_guid(self, value):
        self._domain0_pool_guid = (value, True)

